> For the complete documentation index, see [llms.txt](https://docs.echo3d.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.echo3d.com/api/search.md).

# Search

We integrated 3rd party APIs into a single useful search query for you to retrieve free and paid 3D models, videos, and images. We work with top 3D and 2D content aggregators:

1. [Google Poly](/3d-content/google-poly.md)
2. [Sketchfab](https://sketchfab.com/)
3. [Twinverse](https://twinverse.soreal.ch/) by SO REAL
4. [Unsplash](https://unsplash.com/)
5. [Pexels](https://www.pexels.com/)
6. [Alpha3D](https://www.alpha3d.io/partners/)
7. [Objaverse](https://objaverse.allenai.org/)
8. [TurboSquid](https://www.turbosquid.com/) (coming soon!)
9. [Clara.io](https://clara.io/) (coming soon!)
10. [Thangs](https://www.thangs.com) (coming soon!)
11. [Poly Haven](https://polyhaven.com/) (coming soon!)

## Get 3D models (limited)

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/search?key=<API_KEY>&keywords=<KEYWORDS>`

This query allows you to retrieve free 3D models from a limited collection through 3rd party search engines.

#### Query Parameters

| Name                                       | Type   | Description                                                                                                                             |
| ------------------------------------------ | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>      | string | Your API key.                                                                                                                           |
| keywords<mark style="color:red;">\*</mark> | string | Keywords to search for.                                                                                                                 |
| secKey<mark style="color:red;">\*</mark>   | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| email<mark style="color:red;">\*</mark>    | string | Your email address                                                                                                                      |
| userKey<mark style="color:red;">\*</mark>  | string | Your authentication key                                                                                                                 |

{% tabs %}
{% tab title="200 Search response for the keyword animals." %}

```
[
  {
    "source": "Poly",
    "htmlID": "Elephant",
    "author": "Alex ?SAFFY? Safayan",
    "name": "Elephant",
    "thumbnail": "https://lh3.googleusercontent.com/WFavKRPBkQkYfza9vtanG5Yr02zBZOxt2Dgjr8QyYAWjnxtF6DSig5JS_oQorPQ",
    "gltf_url": "https://poly.googleapis.com/downloads/fp/1586039870059046/eGI3RS52kJA/65zTBuXeSbh/Elephant.gltf",
    "bin_url": "https://poly.googleapis.com/downloads/fp/1586039870059046/eGI3RS52kJA/65zTBuXeSbh/Elephant.bin"
  },
  {
    "source": "Sketchfab",
    "id": "c578c8c12a984e79a6d958a90f86cdc8",
    "htmlID": "Tot-anirà-bé",
    "author": "dimoni",
    "name": "Tot anirà bé",
    "thumbnail": "https://media.sketchfab.com/models/c578c8c12a984e79a6d958a90f86cdc8/thumbnails/f260ae837440436287abef466fe392f8/4b45b9a4dc994f01b05487d0d7fe6d3a.jpeg",
    "url": "https://api.sketchfab.com/v3/models/c578c8c12a984e79a6d958a90f86cdc8/download"
  },
  {
    "source": "Poly",
    "htmlID": "Cow",
    "author": "Poly by Google",
    "name": "Cow",
    "thumbnail": "https://lh3.googleusercontent.com/tMbfIKqyQ-kN2-auLiEnWSqmZRnRBNXntP_m9iKqiRNKjYQrFpy33pKCNucg6MSP",
    "gltf_url": "https://poly.googleapis.com/downloads/fp/1586039818449312/0OToIgkcVM7/48loxcU-Obv/Cow.gltf",
    "bin_url": "https://poly.googleapis.com/downloads/fp/1586039818449312/0OToIgkcVM7/48loxcU-Obv/Cow.bin",
    "png_url": "https://poly.googleapis.com/downloads/fp/1586039818449312/0OToIgkcVM7/48loxcU-Obv/Cow_BaseColor.png"
  },
  {
    "source": "Poly",
    "htmlID": "Ferret",
    "author": "Poly by Google",
    "name": "Ferret",
    "thumbnail": "https://lh3.googleusercontent.com/1pYiy69FLx6WZ2HT75sfIhPfuTmuV2w4iHKLKr_WXxY7Kuqxq3dZroHPhtcl6c0",
    "gltf_url": "https://poly.googleapis.com/downloads/fp/1585993578585478/4I1SBFHWuSo/4KoNOiNyj3s/Ferret.gltf",
    "bin_url": "https://poly.googleapis.com/downloads/fp/1585993578585478/4I1SBFHWuSo/4KoNOiNyj3s/Ferret.bin",
    "png_url": "https://poly.googleapis.com/downloads/fp/1585993578585478/4I1SBFHWuSo/4KoNOiNyj3s/Ferret_BaseColor.png"
  },
  {
    "source": "Sketchfab",
    "id": "a573d7c272c543e0b9cabdfdd6d0da0a",
    "htmlID": "Lady-with-animal---Stone-statue---Bratislava",
    "author": "winky1404",
    "name": "Lady with animal - Stone statue - Bratislava",
    "thumbnail": "https://media.sketchfab.com/models/a573d7c272c543e0b9cabdfdd6d0da0a/thumbnails/e5fedd2429af48e8bd6cc0842a3375ce/2df493213cb14320a60edbc732ffba89.jpeg",
    "url": "https://api.sketchfab.com/v3/models/a573d7c272c543e0b9cabdfdd6d0da0a/download"
  }
]
```

{% endtab %}
{% endtabs %}

## Get 3D models (advanced)

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/search?key=<API_KEY>&keywords=<KEYWORDS>`

This query allows you to retrieve free and paid 3D model from our full collection which included 3rd party search engines.

#### Query Parameters

| Name                                       | Type    | Description                                                                                                                                                               |
| ------------------------------------------ | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>      | string  | Your API key.                                                                                                                                                             |
| secKey<mark style="color:red;">\*</mark>   | string  | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key).                                   |
| email<mark style="color:red;">\*</mark>    | string  | Your email                                                                                                                                                                |
| userKey<mark style="color:red;">\*</mark>  | string  | Your authentication key                                                                                                                                                   |
| keywords<mark style="color:red;">\*</mark> | string  | Keywords to search for.                                                                                                                                                   |
| id                                         | string  | Search for a specific result based on ID.                                                                                                                                 |
| source                                     | string  | Filter search results to only include results from a specific source. Options: `poly`, `sketchfab`, `objaverse`, and `soreal`.                                            |
| minPoly                                    | integer | Filter search results to only include results with this minimal triangle count.                                                                                           |
| maxPoly                                    | integer | Filter search results to only include results with this maximal triangle count.                                                                                           |
| maxResults                                 | integer | Filter search result to only include this amount of results.                                                                                                              |
| gltfpack                                   | boolean | True if the search results should include a URL to a optimized glTF version of the result using the gltfpack tool. Default is `false`. Only applies for supported models. |
| include2Dcontent                           | boolean | True if the search results should include 2D images and videos. Default if `false`.                                                                                       |

{% tabs %}
{% tab title="200 " %}

```
[
  {
    "source": "poly",
    "id": "8p-ZWYlJMnH",
    "name": "CAT",
    "author": "IDI Shopping",
    "license": "CREATIVE_COMMONS_BY",
    "price": "0.0",
    "glb_location_url": "https://storage.echoar.xyz/.../CAT.glb",
    "glb_gltfpack_creation_url": "https://console.echoar.xyz/...",
    "gltf_location_url": "https://storage.echoar.xyz/...",
    "gltf_gltfpack_creation_url": "https://console.echoar.xyz/...",
    "gltf_bin_url": "https://storage.echoar.xyz/...",
    "gltf_textures": "https://storage.echoar.xyz/...|https://storage.echoar.xyz/...",
    "thumbnail": "https://storage.echoar.xyz/...",
    "gltf_triangle_count": "33968"
  },

  ...
  
] 
```

{% endtab %}
{% endtabs %}

{% hint style="success" %}
The Advance Search API is available in the [Pro](https://www.echo3d.com/pricing) and [Custom](mailto:sales@echo3D.com) plans.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.echo3d.com/api/search.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
